module LambdaP.Utils where
import LambdaP.Core

-- # Term utils

(.->.) :: Type -> Type ->  Type
p .->. q = Tall "_" p q 

(/\) :: Type -> Type -> Type
(/\) = Tand

(\/) :: Type -> Type -> Type
(\/) = Tor

π1 = Mpi1
π2 = Mpi2

hlam :: Name -> Type -> (Term -> Term) -> Term
hlam n t mf = Mlam n t (mf (Mvar n))

fun = hlam

and_ind  :: (Term -> Term -> Term) -> Term -> Term
and_ind f q = f (Mpi1 q) (Mpi2 q)

conj :: Type -> Type -> Term -> Term -> Term
conj a b = Mtup (a /\ b)

tyvars :: String -> [Type]
tyvars = map Tvar . words 

mvars :: String -> [Term]
mvars = map Mvar . words 

neg,negneg :: Type -> Type
neg a = a .->. Tbot
negneg = neg . neg
